/***************************************************************************
    conf.c  -  description
    -----------------------
    begin                : pi lut 11 09:59:54 CET 2000
    copyright            : (C) 2000 by Tomasz Fiszer
    email                : profis@kki.net.pl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <unistd.h>
#include "defs.h"
#include "strman.h"
#include "utils.h"
#include "struct.h"


//
// Clearing double quote's
//
void ClearDoubleQuote(char *szBuffer)
{
    int		iCount, 
		iLen = 0;
    
    if (*szBuffer == 0)
	return;
    iLen = strlen(szBuffer);
    if (iLen >= 1024)
	return;
    if (szBuffer[0] == '"')
    {
	for (iCount = 0; iCount < iLen; iCount++)
	{
	    szBuffer[iCount] = szBuffer[iCount + 1];
	}
	szBuffer[iLen] = 0;
	iLen--;
    }
    if (szBuffer[iLen-1] == '"')
	szBuffer[iLen-1] = 0;
}

//
// Clearing all front spaces from string
//
int ClearFrontSpaces(char *szBuffer)
{
    int		iCount, 
		iCnt = 0, 
		iLen = 0;
    
    if (*szBuffer == 0)
	return 0;
    iLen = strlen(szBuffer);
    if (iLen >= 1024)
	return 0;
    while(szBuffer[0] == ' ')
    {
	for (iCount = 0; iCount < iLen; iCount++)
	{
	    szBuffer[iCount] = szBuffer[iCount + 1];
	}
	szBuffer[iLen] = 0;
	iLen--;
	iCnt++;
    }
    return iCnt;
}

//
// Returns configuration string defined by "szVar"
//
int GetConfig_String(char *szConf, char *szVar, 
			char *szDefault, char *szBuffer)
{
    FILE	*f;
    char 	szBuffout[4096];
    int		iCount = 0, iPos = 0, iExist = 0;
    
    f = fopen(szConf, "r");
    if (f == NULL)
    {
	PrintToLog(
	    "Someone is trying to give me bad or"
	    " not existing configuration file!\n");
	return _ERROR_CONFIG;	// Error: open file
    }
    
    // Searching for string occurence
    while(!feof(f))
	iCount += (int)fread(szBuffout, sizeof(char), 1023, f);
	
    fseek(f, SEEK_SET, 0);
    iPos = iCount;
    while(!feof(f))
    {
	*szBuffout = 0;
	fgets(szBuffout, iPos, f);
	ClearFrontSpaces(szBuffout);
	if (!strncasecmp(szBuffout, szVar, strlen(szVar)))
	{
	    if (GetNumArguments(szBuffout, '"', " \t\n") < 2)
		return _ERROR_CONFIG_ENTRY_NULL;
	    else
	    {
		if (strchr(szBuffout, ' '))
		{
		    strcpy(szBuffer, strchr(szBuffout, ' '));
		    iExist = 1;
		    break;
		}
	    }
	}
	iPos += (strlen(szBuffout));
	fseek(f, SEEK_SET, iPos);
    }
    if (iExist == 0)
	strcpy(szBuffer, szDefault);
    else
    {
	if (szBuffer[strlen(szBuffer)-1] == '\n')
	{
	    szBuffer[strlen(szBuffer)-1] = '\0';
	}
    }
    fclose(f);
    return 0; // No Errors
}
