/***************************************************************************
                          utils.h  -  description
                             -------------------
    begin                : pi lut 11 09:59:54 CET 2000
    copyright            : (C) 2000 by Tomasz Fiszer
    email                : profis@kki.net.pl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/
#ifndef _UTILS_H_
#define _UTILS_H_

#include <stdlib.h>
#include <stdio.h>
#include "defs.h"
#include "struct.h"

void PrintError(char *, int, int);
int GetConfig_String(char *, char *, char *, char *);
int CheckSuperUser();
void CreatePID();
int DeleteFile(const char *);
int CreateFile(const char *);
int PrintToLog(char *, ...);
int PrintToLogNet(char *, ...);
void OpenLog();
void CloseLog();
void MsgLog(char *);
void MsgLogError(char *);
void InitSystemSignals();
void InitThreadSignals();
void InitAlarmTimer(int, void (*)(int));
void RestoreSystemSignals();
void StandbyForTermination();
void Standby(int);
int IsStatusSet(unsigned long, unsigned long);
unsigned long SetStatusWord(unsigned long *, unsigned long);
unsigned long ClearStatusWord(unsigned long *, unsigned long);
void BroadcastMessage(UPS_INFO *, char *);
void BroadcastMessageInfo(UPS_INFO *, char *);
void RunCommand(UPS_INFO *, char *);
void RunTimeoutCommand(UPS_INFO *, char *, int);

#endif /*_UTILS_H_*/
